Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.49
retrieving revision 1.49.4.1
diff -u -r1.49 -r1.49.4.1
--- squid/src/store.c	29 Aug 2007 21:52:57 -0000	1.49
+++ squid/src/store.c	27 Nov 2007 08:12:29 -0000	1.49.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.49 2007/08/29 21:52:57 squidadm Exp $
+ * $Id: store.c,v 1.49.4.1 2007/11/27 08:12:29 adri Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -128,7 +128,9 @@
 int
 memHaveHeaders(const MemObject * mem)
 {
-    if (mem->reply == NULL)
+    if (!mem)
+	return 0;
+    if (!mem->reply)
 	return 0;
     if (mem->reply->pstate != psParsed)
 	return 0;
@@ -150,6 +152,16 @@
     return e;
 }
 
+void
+storeEntrySetStoreUrl(StoreEntry * e, const char *store_url)
+{
+    /* XXX eww, another strdup! */
+    if (!e->mem_obj)
+	return;
+    safe_free(e->mem_obj->store_url);
+    e->mem_obj->store_url = xstrdup(store_url);
+}
+
 static void
 destroy_MemObject(StoreEntry * e)
 {
@@ -175,6 +187,10 @@
 	storeUnlockObject(mem->ims_entry);
 	mem->ims_entry = NULL;
     }
+    if (mem->old_entry) {
+	storeUnlockObject(mem->old_entry);
+	mem->old_entry = NULL;
+    }
     httpReplyDestroy(mem->reply);
     requestUnlink(mem->request);
     mem->request = NULL;
@@ -1010,7 +1026,7 @@
 		 * to record the new variance key
 		 */
 		safe_free(request->vary_headers);	/* free old "bad" variance key */
-		pe = storeGetPublic(mem->url, mem->method);
+		pe = storeGetPublic(storeLookupUrl(e), mem->method);
 		if (pe)
 		    storeRelease(pe);
 	    }
@@ -1042,7 +1058,7 @@
 	    stringClean(&vary);
 	}
     } else {
-	newkey = storeKeyPublic(mem->url, mem->method);
+	newkey = storeKeyPublic(storeLookupUrl(e), mem->method);
     }
     if ((e2 = (StoreEntry *) hash_lookup(store_table, newkey))) {
 	debug(20, 3) ("storeSetPublicKey: Making old '%s' private.\n", mem->url);
@@ -1051,7 +1067,7 @@
 	if (mem->request)
 	    newkey = storeKeyPublicByRequest(mem->request);
 	else
-	    newkey = storeKeyPublic(mem->url, mem->method);
+	    newkey = storeKeyPublic(storeLookupUrl(e), mem->method);
     }
     if (e->hash.key)
 	storeHashDelete(e);
@@ -1314,7 +1330,11 @@
     if (e->mem_obj->request)
 	e->mem_obj->request->hier.store_complete_stop = current_time;
 #endif
-    e->mem_obj->refresh_timestamp = e->timestamp;
+    e->mem_obj->refresh_timestamp = 0;
+    if (e->mem_obj->old_entry) {
+	if (e->mem_obj->old_entry->mem_obj)
+	    e->mem_obj->old_entry->mem_obj->refresh_timestamp = 0;
+    }
     /*
      * We used to call InvokeHandlers, then storeSwapOut.  However,
      * Madhukar Reddy <myreddy@persistence.com> reported that
@@ -1338,7 +1358,7 @@
     assert(mem != NULL);
     debug(20, 6) ("storeAbort: %s\n", storeKeyText(e->hash.key));
     storeLockObject(e);		/* lock while aborting */
-    storeNegativeCache(e);
+    storeExpireNow(e);
     storeReleaseRequest(e);
     EBIT_SET(e->flags, ENTRY_ABORTED);
     storeSetMemStatus(e, NOT_IN_MEMORY);
@@ -1627,7 +1647,34 @@
 void
 storeNegativeCache(StoreEntry * e)
 {
-    e->expires = squid_curtime + Config.negativeTtl;
+    StoreEntry *oe = e->mem_obj->old_entry;
+    time_t expires = e->expires;
+    refresh_cc cc = refreshCC(e, e->mem_obj->request);
+    if (expires == -1)
+	expires = squid_curtime + cc.negative_ttl;
+    if (oe && !EBIT_TEST(oe->flags, KEY_PRIVATE) && !EBIT_TEST(oe->flags, ENTRY_REVALIDATE)) {
+	if (cc.max_stale >= 0) {
+	    time_t max_expires;
+	    storeTimestampsSet(oe);
+	    max_expires = oe->expires + cc.max_stale;
+	    /* Bail out if beyond the stale-if-error staleness limit */
+	    if (max_expires <= squid_curtime)
+		goto cache_error_response;
+	    /* Limit expiry time to stale-if-error/max_stale */
+	    if (expires > max_expires)
+		expires = max_expires;
+	}
+	/* Block the new error from getting cached */
+	EBIT_CLR(e->flags, ENTRY_CACHABLE);
+	/* And negatively cache the old one */
+	if (oe->expires < expires)
+	    oe->expires = expires;
+	EBIT_SET(oe->flags, REFRESH_FAILURE);
+	return;
+    }
+  cache_error_response:
+    if (e->expires < expires)
+	e->expires = expires;
     EBIT_SET(e->flags, ENTRY_NEGCACHED);
 }
 
@@ -1819,6 +1866,19 @@
 	return e->mem_obj->url;
 }
 
+const char *
+storeLookupUrl(const StoreEntry * e)
+{
+    if (e == NULL)
+	return "[null_entry]";
+    else if (e->mem_obj == NULL)
+	return "[null_mem_obj]";
+    else if (e->mem_obj->store_url)
+	return e->mem_obj->store_url;
+    else
+	return e->mem_obj->url;
+}
+
 void
 storeCreateMemObject(StoreEntry * e, const char *url)
 {
Index: squid/src/store_client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_client.c,v
retrieving revision 1.25.10.4
retrieving revision 1.25.10.5
diff -u -r1.25.10.4 -r1.25.10.5
--- squid/src/store_client.c	27 Sep 2007 15:09:17 -0000	1.25.10.4
+++ squid/src/store_client.c	27 Nov 2007 08:12:29 -0000	1.25.10.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_client.c,v 1.25.10.4 2007/09/27 15:09:17 adri Exp $
+ * $Id: store_client.c,v 1.25.10.5 2007/11/27 08:12:29 adri Exp $
  *
  * DEBUG: section 20    Storage Manager Client-Side Interface
  * AUTHOR: Duane Wessels
@@ -533,6 +533,18 @@
 		break;
 	    }
 	    break;
+	case STORE_META_STOREURL:
+	    if (NULL == mem->store_url)
+		mem->store_url = xstrdup(t->value);
+	    else if (0 == strcasecmp(mem->store_url, t->value))
+		(void) 0;	/* a match! */
+	    else {
+		debug(20, 1) ("storeClientReadHeader: store URL mismatch\n");
+		debug(20, 1) ("\t{%s} != {%s}\n", (char *) t->value, mem->store_url);
+		swap_object_ok = 0;
+		break;
+	    }
+	    break;
 	case STORE_META_OBJSIZE:
 	    break;
 	case STORE_META_STD:
Index: squid/src/store_key_md5.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_key_md5.c,v
retrieving revision 1.10
retrieving revision 1.10.10.1
diff -u -r1.10 -r1.10.10.1
--- squid/src/store_key_md5.c	21 Jan 2007 14:04:07 -0000	1.10
+++ squid/src/store_key_md5.c	27 Nov 2007 08:12:29 -0000	1.10.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_key_md5.c,v 1.10 2007/01/21 14:04:07 squidadm Exp $
+ * $Id: store_key_md5.c,v 1.10.10.1 2007/11/27 08:12:29 adri Exp $
  *
  * DEBUG: section 20    Storage Manager MD5 Cache Keys
  * AUTHOR: Duane Wessels
@@ -131,7 +131,14 @@
 {
     static cache_key digest[MD5_DIGEST_CHARS];
     unsigned char m = (unsigned char) method;
-    const char *url = urlCanonical(request);
+    const char *url;
+
+    if (request->store_url) {
+	url = request->store_url;
+    } else {
+	url = urlCanonical(request);
+    }
+
     MD5_CTX M;
     MD5Init(&M);
     MD5Update(&M, &m, sizeof(m));
--- /dev/null	Wed Nov 28 01:20:24 2007
+++ squid/src/store_rewrite.c	Wed Nov 28 01:20:25 2007
@@ -0,0 +1,183 @@
+
+/*
+ * $Id: store_rewrite.c,v 1.1.4.2 2007/11/27 08:12:29 adri Exp $
+ *
+ * DEBUG: section 61    Redirector
+ * AUTHOR: Duane Wessels
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+typedef struct {
+    void *data;
+    char *orig_url;
+    struct in_addr client_addr;
+    const char *client_ident;
+    const char *method_s;
+    RH *handler;
+} storeurlStateData;
+
+static HLPCB storeurlHandleReply;
+static void storeurlStateFree(storeurlStateData * r);
+static helper *storeurlors = NULL;
+static OBJH storeurlStats;
+static int n_bypassed = 0;
+CBDATA_TYPE(storeurlStateData);
+
+static void
+storeurlHandleReply(void *data, char *reply)
+{
+    storeurlStateData *r = data;
+    int valid;
+    char *t;
+    debug(61, 5) ("storeurlHandleRead: {%s}\n", reply ? reply : "<NULL>");
+    if (reply) {
+	if ((t = strchr(reply, ' ')))
+	    *t = '\0';
+	if (*reply == '\0')
+	    reply = NULL;
+    }
+    valid = cbdataValid(r->data);
+    cbdataUnlock(r->data);
+    if (valid)
+	r->handler(r->data, reply);
+    storeurlStateFree(r);
+}
+
+static void
+storeurlStateFree(storeurlStateData * r)
+{
+    safe_free(r->orig_url);
+    cbdataFree(r);
+}
+
+static void
+storeurlStats(StoreEntry * sentry)
+{
+    storeAppendPrintf(sentry, "Redirector Statistics:\n");
+    helperStats(sentry, storeurlors);
+    if (Config.onoff.storeurl_bypass)
+	storeAppendPrintf(sentry, "\nNumber of requests bypassed "
+	    "because all store url bypassers were busy: %d\n", n_bypassed);
+}
+
+/**** PUBLIC FUNCTIONS ****/
+
+void
+storeurlStart(clientHttpRequest * http, RH * handler, void *data)
+{
+    ConnStateData *conn = http->conn;
+    storeurlStateData *r = NULL;
+    const char *fqdn;
+    char *urlgroup = conn->port->urlgroup;
+    char buf[8192];
+    char claddr[20];
+    char myaddr[20];
+    assert(http);
+    assert(handler);
+    debug(61, 5) ("storeurlStart: '%s'\n", http->uri);
+    if (Config.onoff.storeurl_bypass && storeurlors->stats.queue_size) {
+	/* Skip storeurlor if there is one request queued */
+	n_bypassed++;
+	handler(data, NULL);
+	return;
+    }
+    r = cbdataAlloc(storeurlStateData);
+    r->orig_url = xstrdup(http->uri);
+    r->client_addr = conn->log_addr;
+    r->client_ident = NULL;
+    if (http->request->auth_user_request)
+	r->client_ident = authenticateUserRequestUsername(http->request->auth_user_request);
+    else if (http->request->extacl_user) {
+	r->client_ident = http->request->extacl_user;
+    }
+    if (!r->client_ident && conn->rfc931[0])
+	r->client_ident = conn->rfc931;
+#if USE_SSL
+    if (!r->client_ident)
+	r->client_ident = sslGetUserEmail(fd_table[conn->fd].ssl);
+#endif
+    if (!r->client_ident)
+	r->client_ident = dash_str;
+    r->method_s = RequestMethods[http->request->method].str;
+    r->handler = handler;
+    r->data = data;
+    cbdataLock(r->data);
+    if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
+	fqdn = dash_str;
+    xstrncpy(claddr, inet_ntoa(r->client_addr), 20);
+    xstrncpy(myaddr, inet_ntoa(http->request->my_addr), 20);
+    snprintf(buf, 8191, "%s %s/%s %s %s %s myip=%s myport=%d",
+	r->orig_url,
+	claddr,
+	fqdn,
+	r->client_ident[0] ? rfc1738_escape(r->client_ident) : dash_str,
+	r->method_s,
+	urlgroup ? urlgroup : "-",
+	myaddr,
+	http->request->my_port);
+    debug(61, 6) ("storeurlStart: sending '%s' to the helper\n", buf);
+    strcat(buf, "\n");
+    helperSubmit(storeurlors, buf, storeurlHandleReply, r);
+}
+
+void
+storeurlInit(void)
+{
+    static int init = 0;
+    if (!Config.Program.store_rewrite.command)
+	return;
+    if (storeurlors == NULL)
+	storeurlors = helperCreate("store_rewriter");
+    storeurlors->cmdline = Config.Program.store_rewrite.command;
+    storeurlors->n_to_start = Config.Program.store_rewrite.children;
+    storeurlors->concurrency = Config.Program.store_rewrite.concurrency;
+    storeurlors->ipc_type = IPC_STREAM;
+    helperOpenServers(storeurlors);
+    if (!init) {
+	cachemgrRegister("store_rewriter",
+	    "URL Rewriter Stats",
+	    storeurlStats, 0, 1);
+	init = 1;
+	CBDATA_INIT_TYPE(storeurlStateData);
+    }
+}
+
+void
+storeurlShutdown(void)
+{
+    if (!storeurlors)
+	return;
+    helperShutdown(storeurlors);
+    if (!shutting_down)
+	return;
+    helperFree(storeurlors);
+    storeurlors = NULL;
+}
Index: squid/src/store_swapmeta.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapmeta.c,v
retrieving revision 1.12
retrieving revision 1.12.22.1
diff -u -r1.12 -r1.12.22.1
--- squid/src/store_swapmeta.c	29 Jul 2006 14:53:20 -0000	1.12
+++ squid/src/store_swapmeta.c	27 Nov 2007 08:12:29 -0000	1.12.22.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapmeta.c,v 1.12 2006/07/29 14:53:20 squidadm Exp $
+ * $Id: store_swapmeta.c,v 1.12.22.1 2007/11/27 08:12:29 adri Exp $
  *
  * DEBUG: section 20    Storage Manager Swapfile Metadata
  * AUTHOR: Kostas Anagnostakis
@@ -86,6 +86,8 @@
     vary = e->mem_obj->vary_headers;
     if (vary)
 	T = storeSwapTLVAdd(STORE_META_VARY_HEADERS, vary, strlen(vary) + 1, T);
+    if (e->mem_obj->store_url)
+	T = storeSwapTLVAdd(STORE_META_STOREURL, e->mem_obj->store_url, strlen(e->mem_obj->store_url) + 1, T);
     return TLV;
 }
 
--- /dev/null	Wed Nov 28 01:20:24 2007
+++ squid/src/store_update.c	Wed Nov 28 01:20:25 2007
@@ -0,0 +1,187 @@
+
+/*
+ * $Id: store_update.c,v 1.2.4.2 2007/11/27 08:12:29 adri Exp $
+ *
+ * DEBUG: section 20    Storage Manager
+ * AUTHOR: Henrik Nordstrom <henrik@henriknordstrom.net>
+ *
+ * Copyright (C) 2007 Henrik Nordstrom <henrik@henriknordstrom.net>
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+/* Update the on-disk representation of the object to match
+ * current in-memory representation. This requires rewriting
+ * the object headers (bot meta and http) which isn't supported
+ * by the store layer today, so we rewrite the full object.
+ */
+
+/* Local state */
+typedef struct {
+    StoreEntry *oldentry;
+    StoreEntry *newentry;
+    store_client *sc;
+    squid_off_t offset;
+    char buf[4096];
+} StoreUpdateState;
+
+CBDATA_TYPE(StoreUpdateState);
+
+static void
+free_StoreUpdateState(void *data)
+{
+    StoreUpdateState *state = data;
+    if (state->sc)
+	storeClientUnregister(state->sc, state->oldentry, state);
+    if (state->oldentry)
+	storeUnlockObject(state->oldentry);
+    if (state->newentry) {
+	/* Set to NULL on completion, so we only get here in abnormal situations */
+	storeRelease(state->newentry);
+	storeUnlockObject(state->newentry);
+    }
+}
+
+static void
+storeUpdateDone(StoreUpdateState * state)
+{
+    if (state->sc) {
+	store_client *sc = state->sc;
+	state->sc = NULL;
+	storeClientUnregister(sc, state->oldentry, state);
+    }
+    cbdataFree(state);
+}
+static void
+storeUpdateAbort(void *data)
+{
+    StoreUpdateState *state = data;
+    storeUpdateDone(state);
+}
+
+static void
+storeUpdateCopy(void *data, char *buf, ssize_t size)
+{
+    StoreUpdateState *state = data;
+
+    if (EBIT_TEST(state->newentry->flags, ENTRY_ABORTED)) {
+	debug(20, 1) ("storeUpdateCopy: Aborted at %d (%d)\n", (int) state->offset, (int) size);
+	/* the abort callback deals with the needed cleanup */
+	return;
+    }
+    if (EBIT_TEST(state->newentry->flags, KEY_PRIVATE) && state->newentry->mem_obj->nclients == 0) {
+	debug(20, 2) ("storeUpdateCopy: Gone stale with no clients, skip copying of the rest\n");
+	storeUpdateDone(state);
+	return;
+    }
+    if (size < 0) {
+	debug(20, 1) ("storeUpdateCopy: Error at %d (%d)\n", (int) state->offset, (int) size);
+	storeUpdateDone(state);
+	return;
+    }
+    if (size > 0) {
+	storeAppend(state->newentry, buf, size);
+	if (EBIT_TEST(state->newentry->flags, ENTRY_ABORTED)) {
+	    debug(20, 1) ("storeUpdateCopy: Aborted on write at %d (%d)\n", (int) state->offset, (int) size);
+	    return;
+	}
+	state->offset += size;
+	storeClientCopy(state->sc, state->oldentry, state->offset, state->offset, sizeof(state->buf), state->buf, storeUpdateCopy, state);
+	return;
+    } else {
+	storeComplete(state->newentry);
+	storeUnlockObject(state->newentry);
+	state->newentry = NULL;
+	storeUpdateDone(state);
+    }
+}
+
+void
+storeUpdate(StoreEntry * entry, request_t * request)
+{
+    StoreUpdateState *state;
+    request_flags flags = null_request_flags;
+    const char *vary;
+
+    if (!request)
+	request = entry->mem_obj->request;
+
+    if (EBIT_TEST(entry->flags, KEY_PRIVATE))
+	return;			/* Nothing to do here... */
+
+    if (!Config.onoff.update_headers)
+	return;			/* Disabled */
+
+    CBDATA_INIT_TYPE_FREECB(StoreUpdateState, free_StoreUpdateState);
+
+    if (entry->mem_obj)
+	entry->mem_obj->refresh_timestamp = 0;
+    state = cbdataAlloc(StoreUpdateState);
+    state->oldentry = entry;
+    storeLockObject(state->oldentry);
+    flags.cachable = 1;
+    state->newentry = storeCreateEntry(storeUrl(entry), flags, entry->mem_obj->method);
+    storeRegisterAbort(state->newentry, storeUpdateAbort, state);
+    state->sc = storeClientRegister(state->oldentry, state);
+    state->offset = entry->mem_obj->reply->hdr_sz;
+    storeBuffer(state->newentry);
+    httpReplySwapOut(httpReplyClone(entry->mem_obj->reply), state->newentry);
+    state->newentry->timestamp = entry->timestamp;
+    state->newentry->lastref = entry->lastref;
+    state->newentry->expires = entry->expires;
+    state->newentry->lastmod = entry->lastmod;
+    state->newentry->refcount = entry->refcount;
+    if (request) {
+	state->newentry->mem_obj->request = requestLink(request);
+	vary = httpMakeVaryMark(request, state->newentry->mem_obj->reply);
+	if (vary) {
+	    state->newentry->mem_obj->vary_headers = xstrdup(vary);
+	    if (strBuf(request->vary_encoding))
+		entry->mem_obj->vary_encoding = xstrdup(strBuf(request->vary_encoding));
+	}
+    } else {
+	if (entry->mem_obj->vary_headers)
+	    state->newentry->mem_obj->vary_headers = xstrdup(entry->mem_obj->vary_headers);
+	if (entry->mem_obj->vary_encoding)
+	    state->newentry->mem_obj->vary_encoding = xstrdup(entry->mem_obj->vary_encoding);
+    }
+    storeSetPublicKey(state->newentry);
+    storeBufferFlush(state->newentry);
+    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+	/*
+	 * the above storeBufferFlush() call could ABORT this entry,
+	 * in that case, there's nothing for us to do.
+	 */
+	debug(20, 1) ("storeUpdate: Aborted on write\n");
+	return;
+    }
+    storeClientCopy(state->sc, state->oldentry, state->offset, state->offset, sizeof(state->buf), state->buf, storeUpdateCopy, state);
+    return;
+}
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.158.2.4
retrieving revision 1.158.2.5
diff -u -r1.158.2.4 -r1.158.2.5
--- squid/src/structs.h	26 Sep 2007 07:33:50 -0000	1.158.2.4
+++ squid/src/structs.h	27 Nov 2007 08:12:29 -0000	1.158.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.158.2.4 2007/09/26 07:33:50 adri Exp $
+ * $Id: structs.h,v 1.158.2.5 2007/11/27 08:12:29 adri Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -443,6 +443,7 @@
     RemovalPolicySettings *replPolicy;
     RemovalPolicySettings *memPolicy;
     time_t negativeTtl;
+    time_t maxStale;
     time_t negativeDnsTtl;
     time_t positiveDnsTtl;
     time_t shutdownLifetime;
@@ -549,7 +550,13 @@
 	    wordlist *command;
 	    int children;
 	    int concurrency;
+	} store_rewrite;
+	struct {
+	    wordlist *command;
+	    int children;
+	    int concurrency;
 	} location_rewrite;
+	refresh_check_helper *refresh_check;
 #if USE_ICMP
 	char *pinger;
 #endif
@@ -652,6 +659,7 @@
 	int nonhierarchical_direct;
 	int strip_query_terms;
 	int redirector_bypass;
+	int storeurl_bypass;
 	int ignore_unknown_nameservers;
 	int client_pconns;
 	int server_pconns;
@@ -672,6 +680,7 @@
 	int global_internal_static;
 	int httpd_suppress_version_string;
 	int via;
+	int ignore_ims_on_miss;
 	int check_hostnames;
 	int allow_underscore;
 	int cache_vary;
@@ -680,6 +689,7 @@
 	int delay_pool_uses_indirect_client;
 	int log_uses_indirect_client;
 #endif
+	int update_headers;
     } onoff;
     acl *aclList;
     struct {
@@ -700,6 +710,7 @@
 	acl_access *identLookup;
 #endif
 	acl_access *url_rewrite;
+	acl_access *storeurl_rewrite;
 	acl_access *location_rewrite;
 	acl_access *reply;
 	acl_address *outgoing_address;
@@ -1190,6 +1201,7 @@
     HierarchyLogEntry hier;
     HttpReply *reply;
     request_t *request;
+    char *ext_refresh;
 };
 
 struct _clientHttpRequest {
@@ -1238,6 +1250,9 @@
     dlink_node active;
     squid_off_t maxBodySize;
     mem_node_ref nr;
+    STHCB *header_callback;	/* Temporarily here for storeClientCopyHeaders */
+    StoreEntry *header_entry;	/* Temporarily here for storeClientCopyHeaders */
+    int is_modified;
 };
 
 struct _ConnStateData {
@@ -1698,6 +1713,7 @@
 struct _MemObject {
     method_t method;
     char *url;
+    const char *store_url;
     mem_hdr data_hdr;
     squid_off_t inmem_hi;
     squid_off_t inmem_lo;
@@ -1730,7 +1746,9 @@
     const char *vary_headers;
     const char *vary_encoding;
     StoreEntry *ims_entry;
+    StoreEntry *old_entry;
     time_t refresh_timestamp;
+    time_t stale_while_revalidate;
 };
 
 struct _StoreEntry {
@@ -1885,6 +1903,7 @@
     u_short port;
     String urlpath;
     char *canonical;
+    char *store_url;		/* rewritten URL for store lookup/storage; if NULL use canonical */
     int link_count;		/* free when zero */
     request_flags flags;
     HttpHdrCc *cache_control;
@@ -1936,6 +1955,11 @@
     cachemgr_passwd *next;
 };
 
+struct _refresh_cc {
+    int max_stale;
+    int negative_ttl;
+};
+
 struct _refresh_t {
     const char *pattern;
     regex_t compiled_pattern;
@@ -1955,6 +1979,9 @@
 	unsigned int ignore_auth:1;
 #endif
     } flags;
+    int max_stale;
+    int stale_while_revalidate;
+    int negative_ttl;
 };
 
 struct _ErrorState {
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.43.2.2
retrieving revision 1.43.2.3
diff -u -r1.43.2.2 -r1.43.2.3
--- squid/src/typedefs.h	25 Sep 2007 00:29:28 -0000	1.43.2.2
+++ squid/src/typedefs.h	27 Nov 2007 08:12:29 -0000	1.43.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.43.2.2 2007/09/25 00:29:28 adri Exp $
+ * $Id: typedefs.h,v 1.43.2.3 2007/11/27 08:12:29 adri Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -188,6 +188,7 @@
 typedef struct _AccessLogEntry AccessLogEntry;
 typedef struct _cachemgr_passwd cachemgr_passwd;
 typedef struct _refresh_t refresh_t;
+typedef struct _refresh_cc refresh_cc;
 typedef struct _CommWriteStateData CommWriteStateData;
 typedef struct _ErrorState ErrorState;
 typedef struct _dlink_node dlink_node;
@@ -289,6 +290,7 @@
 typedef int QS(const void *, const void *);	/* qsort */
 typedef void STCB(void *, char *, ssize_t);	/* store callback */
 typedef void STNCB(void *, struct _mem_node_ref r, ssize_t);	/* new store callback */
+typedef void STHCB(void *, HttpReply *);	/* store callback */
 typedef void STABH(void *);
 typedef void ERCB(int fd, void *, size_t);
 typedef void OBJH(StoreEntry *);
@@ -429,4 +431,6 @@
 typedef void LOGROTATE(Logfile *);
 typedef void LOGCLOSE(Logfile *);
 
+typedef void REFRESHCHECK(void *data, int fresh, const char *log);
+typedef struct _refresh_check_helper refresh_check_helper;
 #endif /* SQUID_TYPEDEFS_H */
Index: squid/src/fs/aufs/aiops.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/aiops.c,v
retrieving revision 1.28
retrieving revision 1.28.18.1
diff -u -r1.28 -r1.28.18.1
--- squid/src/fs/aufs/aiops.c	23 Sep 2006 10:51:41 -0000	1.28
+++ squid/src/fs/aufs/aiops.c	27 Nov 2007 08:12:30 -0000	1.28.18.1
@@ -322,7 +322,7 @@
     /* Create threads and get them to sit in their wait loop */
     squidaio_thread_pool = memPoolCreate("aio_thread", sizeof(squidaio_thread_t));
     if (squidaio_nthreads == 0) {
-	int j = 16;
+	int j = THREAD_FACTOR;
 	for (i = 0; i < n_asyncufs_dirs; i++) {
 	    squidaio_nthreads += j;
 	    j = j * 2 / 3;
@@ -338,7 +338,7 @@
 #endif
     }
     if (squidaio_nthreads == 0)
-	squidaio_nthreads = 16;
+	squidaio_nthreads = THREAD_FACTOR;
     squidaio_magic1 = squidaio_nthreads * MAGIC1_FACTOR;
     squidaio_magic2 = squidaio_nthreads * MAGIC2_FACTOR;
     for (i = 0; i < squidaio_nthreads; i++) {
Index: squid/src/fs/aufs/aiops_win32.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/aiops_win32.c,v
retrieving revision 1.4
retrieving revision 1.4.28.1
diff -u -r1.4 -r1.4.28.1
--- squid/src/fs/aufs/aiops_win32.c	23 Sep 2006 10:51:41 -0000	1.4
+++ squid/src/fs/aufs/aiops_win32.c	27 Nov 2007 08:12:30 -0000	1.4.28.1
@@ -1,5 +1,5 @@
 /*
- * $Id: aiops_win32.c,v 1.4 2006/09/23 10:51:41 squidadm Exp $
+ * $Id: aiops_win32.c,v 1.4.28.1 2007/11/27 08:12:30 adri Exp $
  *
  * DEBUG: section 43    Windows AIOPS
  * AUTHOR: Stewart Forster <slf@connect.com.au>
@@ -322,7 +322,7 @@
     /* Create threads and get them to sit in their wait loop */
     squidaio_thread_pool = memPoolCreate("aio_thread", sizeof(squidaio_thread_t));
     if (squidaio_nthreads == 0) {
-	int j = 16;
+	int j = THREAD_FACTOR;
 	for (i = 0; i < n_asyncufs_dirs; i++) {
 	    squidaio_nthreads += j;
 	    j = j * 2 / 3;
@@ -338,7 +338,7 @@
 #endif
     }
     if (squidaio_nthreads == 0)
-	squidaio_nthreads = 16;
+	squidaio_nthreads = THREAD_FACTOR;
     squidaio_magic1 = squidaio_nthreads * MAGIC1_FACTOR;
     squidaio_magic2 = squidaio_nthreads * MAGIC2_FACTOR;
     for (i = 0; i < squidaio_nthreads; i++) {
Index: squid/src/fs/aufs/store_dir_aufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/store_dir_aufs.c,v
retrieving revision 1.50
retrieving revision 1.50.6.1
diff -u -r1.50 -r1.50.6.1
--- squid/src/fs/aufs/store_dir_aufs.c	1 Mar 2007 07:53:23 -0000	1.50
+++ squid/src/fs/aufs/store_dir_aufs.c	27 Nov 2007 08:12:30 -0000	1.50.6.1
@@ -1551,6 +1551,8 @@
 	    break;		/* no more objects */
 	removed++;
 	storeRelease(e);
+	if (aioQueueSize() > MAGIC2)
+	    break;
     }
     walker->Done(walker);
     debug(47, (removed ? 2 : 3)) ("storeAufsDirMaintain: %s removed %d/%d f=%.03f max_scan=%d\n",
